# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::DataBoxEdge::Mgmt::V2019_08_01
  module Models
    #
    # Represents a container on the  Data Box Edge/Gateway device.
    #
    class Container < ARMBaseModel

      include MsRestAzure

      # @return [ContainerStatus] Current status of the container. Possible
      # values include: 'OK', 'Offline', 'Unknown', 'Updating',
      # 'NeedsAttention'
      attr_accessor :container_status

      # @return [AzureContainerDataFormat] DataFormat for Container. Possible
      # values include: 'BlockBlob', 'PageBlob', 'AzureFile'
      attr_accessor :data_format

      # @return [RefreshDetails] Details of the refresh job on this container.
      attr_accessor :refresh_details

      # @return [DateTime] The UTC time when container got created.
      attr_accessor :created_date_time


      #
      # Mapper for Container class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'Container',
          type: {
            name: 'Composite',
            class_name: 'Container',
            model_properties: {
              id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'id',
                type: {
                  name: 'String'
                }
              },
              name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              type: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'type',
                type: {
                  name: 'String'
                }
              },
              container_status: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.containerStatus',
                type: {
                  name: 'String'
                }
              },
              data_format: {
                client_side_validation: true,
                required: true,
                serialized_name: 'properties.dataFormat',
                type: {
                  name: 'String'
                }
              },
              refresh_details: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.refreshDetails',
                type: {
                  name: 'Composite',
                  class_name: 'RefreshDetails'
                }
              },
              created_date_time: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.createdDateTime',
                type: {
                  name: 'DateTime'
                }
              }
            }
          }
        }
      end
    end
  end
end
