# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::DataBoxEdge::Mgmt::V2019_08_01
  module Models
    #
    # Represents a Storage Account on the  Data Box Edge/Gateway device.
    #
    class StorageAccount < ARMBaseModel

      include MsRestAzure

      # @return [String] Description for the storage Account.
      attr_accessor :description

      # @return [StorageAccountStatus] Current status of the storage account.
      # Possible values include: 'OK', 'Offline', 'Unknown', 'Updating',
      # 'NeedsAttention'
      attr_accessor :storage_account_status

      # @return [DataPolicy] Data policy of the storage Account. Possible
      # values include: 'Cloud', 'Local'
      attr_accessor :data_policy

      # @return [String] Storage Account Credential Id
      attr_accessor :storage_account_credential_id

      # @return [String] BlobEndpoint of Storage Account
      attr_accessor :blob_endpoint

      # @return [Integer] The Container Count. Present only for Storage
      # Accounts with DataPolicy set to Cloud.
      attr_accessor :container_count


      #
      # Mapper for StorageAccount class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'StorageAccount',
          type: {
            name: 'Composite',
            class_name: 'StorageAccount',
            model_properties: {
              id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'id',
                type: {
                  name: 'String'
                }
              },
              name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              type: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'type',
                type: {
                  name: 'String'
                }
              },
              description: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.description',
                type: {
                  name: 'String'
                }
              },
              storage_account_status: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.storageAccountStatus',
                type: {
                  name: 'String'
                }
              },
              data_policy: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.dataPolicy',
                type: {
                  name: 'String'
                }
              },
              storage_account_credential_id: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.storageAccountCredentialId',
                type: {
                  name: 'String'
                }
              },
              blob_endpoint: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.blobEndpoint',
                type: {
                  name: 'String'
                }
              },
              container_count: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.containerCount',
                type: {
                  name: 'Number'
                }
              }
            }
          }
        }
      end
    end
  end
end
